// rdll.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "rdll.h"

#include "TTree.h"
#include "TFile.h"
#include "TBranch.h"
#include "TLeaf.h"



#pragma data_seg (".SHARED")
int i=0;
double shared[1024*4096];
double testpid;
#pragma data_seg()



typedef struct TTree TTree;
typedef struct TFile TFile;
typedef struct TBranch TBranch;

union {
	char b[8];
	double d;
	float f;
} NAN={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};


RDLL_API TFile* lvTFile(const char *fname, char *option=""){
	return new TFile(fname,option);
}
RDLL_API TTree* lvTFileGetTree(TFile *f, const char *name){
	return (TTree*) f->Get(name);
}
RDLL_API int lvTFileClose(TFile* f){
	f->Close();
	return 0;
}
RDLL_API int lvTFileWrite(TFile* f, int overwrite=0){
	if(overwrite) {
		return f->Write("",TObject::kOverwrite);
	}else{
		return f->Write();
	};
}

RDLL_API TTree* lvTTree(const char *tname, const char* title, int splitlevel=99,TFile* f=NULL){

	if(f!=NULL) f->cd();
	return new TTree(tname,title,splitlevel);
}
RDLL_API int lvTTreeWrite(TTree* t, int overwrite=0){
	if(overwrite) {
		return t->Write("",TObject::kOverwrite);
	}else{
		return t->Write();
	};
}
RDLL_API int lvTTreeFill(TTree* t){
	return t->Fill();
}
RDLL_API int lvTTreeGetEntriesFast(TTree* t){
	return t->GetEntriesFast();
}


RDLL_API TBranch* lvTTreeBranch_short(TTree* t, const char *name, void *addr){
	return t->Branch(name,addr);
}
RDLL_API TBranch* lvTTreeBranch(TTree* t, const char *name, void *addr, const char* leaflist,int bs=32000){
	return t->Branch(name,addr,leaflist,bs);
}
RDLL_API TBranch* lvTTreeBranchU8(TTree* t, const char *name, unsigned short int *addr, const char* leaflist,int bs=32000){
	return t->Branch(name,addr,leaflist,bs);
}

RDLL_API void lvTTreeSetBranchStatus(TTree* t,const char *n,int v){
	t->SetBranchStatus(n,v);
}

RDLL_API int lvTTreeSetBranchAddress(TTree* t,const char *n,void* addr){
	return t->SetBranchAddress(n,addr,(TBranch**)0);
}
RDLL_API void lvTTreeSetBranchAddressByBPtr(TBranch *b,void *addr){
	b->SetAddress(addr);
}
RDLL_API TBranch* lvTTreeSetBranchAddressU8(TTree* t,const char *n,unsigned short int *addr){
	t->SetBranchAddress(n,addr);
	return t->GetBranch(n);
}
RDLL_API void lvTTreeSetBranchAddressU8ByBPtr(TBranch *b,unsigned short int *addr){
	b->SetAddress(addr);
}


RDLL_API int lvTBranchFill(TTree *t,TBranch* b){
	int res;
	res=b->Fill();
	t->SetEntries(-1);
	return res;
}

RDLL_API int lvTBranchFillWR(TTree *t,TBranch* b){	
	t->SetBranchStatus("*",0);
	t->SetBranchStatus(b->GetName(),1);
	return t->Fill();;
}

RDLL_API void* p2i(void *p){
	return p;
}


// SHARED FUNCTIONALITY
RDLL_API void getshared(double *r,int size=0){
	if (size>1024) size=1024;
	for(int i=0;i<size;i++) r[i]=shared[i];
}
RDLL_API void setshared(double *r,int size=0){
	if (size>1024) size=1024;
	for(int i=0;i<size;i++) shared[i]=r[i];
}
RDLL_API void initshared(void){
	for(int i=0;i<1024;i++) shared[i]=i;//shared[i]=NAN.d;
}
